//+------------------------------------------------------------------+
//|                                                      MACROSS.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern double Lots              =  0.1;   
extern double StopLoss          =  0;   
extern double TakeProfit        =  0;   
extern double FASTPERIOD        =  1;  
extern double SLOWPERIOD        =  1;   
//----------------------------------   ----------------------------
int        Magic          =    777;               // Magic number
string     TradeComment   =    "";                //    
string     Expert         =    "PARANOiA";       //  
int        Slippage       =    3;                 // 


double SL, TP, TakeProfitT, StopLossT, PrevPrice=0;
int BuyOrders, SellOrders, TotalOrders, LastOpenTime, ticket, cnt, StopLevel, Operation=0, PrevTime=0,i;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
    Magic=MagicfromSymbol();
    TradeComment=Expert+"_"+Symbol()+"_M"+Period();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
 if (PrevTime==Time[0]) return;
 
 PrevTime=Time[0];

 double MAFAST1=iMA(NULL,0,FASTPERIOD,0,MODE_SMA,PRICE_CLOSE,1);
 double MAFAST2=iMA(NULL,0,FASTPERIOD,0,MODE_SMA,PRICE_CLOSE,2);
 double MASLOW1=iMA(NULL,0,FASTPERIOD+SLOWPERIOD,0,MODE_SMA,PRICE_CLOSE,1);
 double MASLOW2=iMA(NULL,0,FASTPERIOD+SLOWPERIOD,0,MODE_SMA,PRICE_CLOSE,2);
 
 if (MAFAST1<MASLOW1 && MAFAST2>MASLOW2) Operation=-11;
 if (MAFAST1>MASLOW1 && MAFAST2<MASLOW2) Operation=11;
 
 for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
 {
   if (!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
   if( OrderSymbol()!=Symbol() || OrderMagicNumber()!=Magic) continue;

   if(OrderType()==OP_BUY)
   {
         if (Operation==-1 || Operation==-11 )
         { 
             if (!OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Blue)) 
                {Print("OrderClose of BuyOrder failed with error #",GetLastError()); return(0);}
             else continue;
         }
        /* if (Operation==11 && Modify)
         {
             if (StopLoss<0.1) SL=0; else SL=NormalizeDouble(Bid-MathMax(StopLevel+1, StopLoss)*Point, Digits);
             if (TakeProfit<0.1) TP=0; else TP=NormalizeDouble(Bid+MathMax(StopLevel+1, TakeProfit)*Point, Digits);
             if (!OrderModify(OrderTicket(),OrderOpenPrice(),SL, TP,0,Blue))
                      Print("Modify of BuyOrder failed with error #",GetLastError());
             else  Operation=0;
          }*/
       }
       if(OrderType()==OP_SELL)
       {
         if (Operation==1 || Operation==11)
         { 
             if (!OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Red)) 
                {Print("OrderClose of SellOrder failed with error #",GetLastError()); return(0);}
             else continue;
         }
        /* if (Operation==-11 && Modify)
         {
             if (StopLoss<0.1) SL=0; else SL=NormalizeDouble(Ask+MathMax(StopLevel+1, StopLoss)*Point, Digits);
             if (TakeProfit<0.1) TP=0; else TP=NormalizeDouble(Ask-MathMax(StopLevel+1, TakeProfit)*Point, Digits);
             if (!OrderModify(OrderTicket(),OrderOpenPrice(),SL, TP,0,Red))
                      Print("Modify of SellOrder failed with error #",GetLastError());
             else  Operation=0;
         }*/
       }
    }    
    
    OrdersRecount();
    RefreshRates();
    StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);

    if (Operation==11 && BuyOrders<1)
    {
      if (StopLoss<0.1) SL=0; else SL=NormalizeDouble(Bid-MathMax(StopLevel+1, StopLoss)*Point, Digits);
      if (TakeProfit<0.1) TP=0; else TP=NormalizeDouble(Bid+MathMax(StopLevel+1, TakeProfit)*Point, Digits);
      if (OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),Slippage,SL,TP,TradeComment,Magic,Blue)<0)
         Print("OrderSend failed with error #",GetLastError());
      else Operation =0;          
     }

     if (Operation==-11 && SellOrders<1)
     {
         if (StopLoss<0.1) SL=0; else SL=NormalizeDouble(Ask+MathMax(StopLevel+1, StopLoss)*Point, Digits);
         if (TakeProfit<0.1) TP=0; else TP=NormalizeDouble(Ask-MathMax(StopLevel+1, TakeProfit)*Point, Digits);
         if (OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,Digits),Slippage,SL,TP,TradeComment,Magic,Blue)<0)
            Print("OrderSend failed with error #",GetLastError());
         else Operation =0;          
     }
   return(0);
  }
//+------------------------------------------------------------------+



void OrdersRecount()
{
   BuyOrders=0; SellOrders=0; TotalOrders=0;
   if (OrdersTotal()>0)
   {
     for (int j = 0; j < OrdersTotal(); j++) 
     {
      if (OrderSelect(j, SELECT_BY_POS)) 
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
         {
          if (OrderType() == OP_BUY) BuyOrders++;
          if (OrderType() == OP_SELL) SellOrders++;        
          TotalOrders++;
         }
       }
     } 
   }
}

int MagicfromSymbol() //  Magicnumber     
{  
   int MagicNumber=0;  
   for (int i=0; i<5; i++) 
   {  
      MagicNumber=MagicNumber*3+StringGetChar(Symbol(),i)+5;  
   }  
   MagicNumber=MagicNumber*3+Period();  
   return(MagicNumber);  
}


